unit CustomerEditorFormFB;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ActnList, Vcl.StdCtrls,
  CommonUnit, Vcl.ExtCtrls, Vcl.DBCtrls, Vcl.Grids, Vcl.DBGrids, Data.DB,
  EchoModuleFB,
  Aurelius.Drivers.Interfaces, Aurelius.Engine.ObjectManager, Aurelius.Bind.Dataset,
  Aurelius.Bind.BaseDataset;

type
  TfmCustomerEditorFB = class(TForm)
    btRefresh: TButton;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    AureliusDataset1: TAureliusDataset;
    DBGrid1: TDBGrid;
    btPush: TButton;
    btPull: TButton;
    cbAutomatic: TCheckBox;
    PushTimer: TTimer;
    PullTimer: TTimer;
    AureliusDataset1LINE_NM: TStringField;
    procedure FormDestroy(Sender: TObject);
    procedure acAutomaticPushPullExecute(Sender: TObject);
    procedure btPushClick(Sender: TObject);
    procedure btPullClick(Sender: TObject);
    procedure btRefreshClick(Sender: TObject);
    procedure PushTimerTimer(Sender: TObject);
    procedure PullTimerTimer(Sender: TObject);
  private
    FManager: TObjectManager;
    FModule: TdmEchoFB;
    procedure RefreshData;
  public
    constructor Create(AOwner: TComponent; AModule: TdmEchoFB); reintroduce;
  end;

implementation

{$R *.dfm}

{ TfmCustomerEditor }

procedure TfmCustomerEditorFB.acAutomaticPushPullExecute(Sender: TObject);
begin
  PullTimer.Enabled := cbAutomatic.Checked;
  PushTimer.Enabled := cbAutomatic.Checked;
  btPush.Visible := not PushTimer.Enabled;
  btPull.Visible := not PullTimer.Enabled;
end;

procedure TfmCustomerEditorFB.btRefreshClick(Sender: TObject);
begin
  RefreshData;
end;

procedure TfmCustomerEditorFB.btPushClick(Sender: TObject);
begin
  FModule.Push;
end;

procedure TfmCustomerEditorFB.btPullClick(Sender: TObject);
begin
  FModule.Pull;
end;

constructor TfmCustomerEditorFB.Create(AOwner: TComponent; AModule: TdmEchoFB);
begin
  inherited Create(AOwner);
  FModule := AModule;
  FManager := TObjectManager.Create(AModule.Echo.Pool.GetConnection);
  Caption := AModule.DBName;
  AureliusDataset1.Manager := FManager;
  RefreshData;
end;

procedure TfmCustomerEditorFB.FormDestroy(Sender: TObject);
begin
  AureliusDataset1.Close;
  FManager.Free;
end;

procedure TfmCustomerEditorFB.PullTimerTimer(Sender: TObject);
begin
  FModule.Pull;
end;

procedure TfmCustomerEditorFB.PushTimerTimer(Sender: TObject);
begin
  FModule.Push;
end;

procedure TfmCustomerEditorFB.RefreshData;
begin
  AureliusDataset1.Close;
  FManager.Clear;
  AureliusDataset1.SetSourceCriteria(FManager.Find<TTblMsLine>);
  AureliusDataset1.Open;
end;

end.
