unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, CustomerEditorFormFB,
  Echo.Listeners;

type
  TfmMain = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FEchoSubscriber: TEchoEventSubscriber;

    FClient1Form: TfmCustomerEditorFB;
    FClient2Form: TfmCustomerEditorFB;
    FServerForm: TfmCustomerEditorFB;
    procedure RepositionForms;
  public
  end;

var
  fmMain: TfmMain;

implementation

uses
  Aurelius.Engine.ObjectManager,
  EchoModuleFB, FBConnection;

{$R *.dfm}

procedure TfmMain.Button1Click(Sender: TObject);
begin
  // Use Echo subscriber to log all changes for later replication
  // The subscription is made by TMappingExplorer. In this case we're
  // subscribing to the default mapping explorer (calling SubscribeListeners without params)
  FEchoSubscriber := TEchoEventSubscriber.Create;
  FEchoSubscriber.SubscribeListeners;


//  FServerForm := TfmCustomerEditorFB.Create(Application, TdmEcho.Create(Application, 'server'));
//  FServerForm.Show;
//
//  FClient1Form := TfmCustomerEditorFB.Create(Application, TdmEcho.Create(Application, 'client1', 'server'));
//  FClient1Form.Show;
//
//  FClient2Form := TfmCustomerEditorFB.Create(Application, TdmEcho.Create(Application, 'client2', 'server'));
//  FClient2Form.Show;

  FServerForm := TfmCustomerEditorFB.Create(Application, TdmEchoFB.Create(Application, 'server', dmFBConnection.conMaster));
  FServerForm.Show;

  FClient1Form := TfmCustomerEditorFB.Create(Application, TdmEchoFB.Create(Application, 'client1', dmFBConnection.conNode1, dmFBConnection.conMaster));
  FClient1Form.Show;

  FClient2Form := TfmCustomerEditorFB.Create(Application, TdmEchoFB.Create(Application, 'client2', dmFBConnection.conNode2, dmFBConnection.conMaster));
  FClient2Form.Show;

  RepositionForms;

end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
{
  // Use Echo subscriber to log all changes for later replication
  // The subscription is made by TMappingExplorer. In this case we're
  // subscribing to the default mapping explorer (calling SubscribeListeners without params)
  FEchoSubscriber := TEchoEventSubscriber.Create;
  FEchoSubscriber.SubscribeListeners;


//  FServerForm := TfmCustomerEditorFB.Create(Application, TdmEcho.Create(Application, 'server'));
//  FServerForm.Show;
//
//  FClient1Form := TfmCustomerEditorFB.Create(Application, TdmEcho.Create(Application, 'client1', 'server'));
//  FClient1Form.Show;
//
//  FClient2Form := TfmCustomerEditorFB.Create(Application, TdmEcho.Create(Application, 'client2', 'server'));
//  FClient2Form.Show;

  FServerForm := TfmCustomerEditorFB.Create(Application, TdmEchoFB.Create(Application, 'server', dmFBConnection.conMaster));
  FServerForm.Show;

  FClient1Form := TfmCustomerEditorFB.Create(Application, TdmEchoFB.Create(Application, 'client1', dmFBConnection.conNode1, dmFBConnection.conMaster));
  FClient1Form.Show;

  FClient2Form := TfmCustomerEditorFB.Create(Application, TdmEchoFB.Create(Application, 'client2', dmFBConnection.conNode2, dmFBConnection.conMaster));
  FClient2Form.Show;
}
end;

procedure TfmMain.FormDestroy(Sender: TObject);
begin
  // Stop logging
  FEchoSubscriber.UnsubscribeListeners;
  FEchoSubscriber.Free;
end;

procedure TfmMain.FormShow(Sender: TObject);
begin
//  RepositionForms;
end;

procedure TfmMain.RepositionForms;
begin
  // Just visual arrangements of the forms
  FClient1Form.Left := FServerForm.Left - FClient1Form.Width - 30;
  FClient2Form.Left := FServerForm.Left + FServerForm.Width + 30;
  Self.Top := FServerForm.Top - Self.Height - 30;
  Self.Left := FServerForm.Left + FServerForm.Width div 2 - Self.Width div 2;
end;

end.
